package com.company.demo.app;

import com.company.demo.entity.User;
import io.jmix.core.UnconstrainedDataManager;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Component;

@Component
public class RegistrationService {

    private final UnconstrainedDataManager unconstrainedDataManager;
    private final PasswordEncoder passwordEncoder;

    public RegistrationService(UnconstrainedDataManager unconstrainedDataManager,
                               PasswordEncoder passwordEncoder) {
        this.unconstrainedDataManager = unconstrainedDataManager;
        this.passwordEncoder = passwordEncoder;
    }

    public void register(String firstName, String lastName, String username, String email, String password) {
        // check of  username or email are already taken or password too weak
        User user = unconstrainedDataManager.create(User.class);
        user.setFirstName(firstName);
        user.setLastName(lastName);
        user.setUsername(username);
        user.setEmail(email);
        user.setPassword(passwordEncoder.encode(password));

        unconstrainedDataManager.save(user);
    }
}