package com.company.demo.view.registration;


import com.company.demo.app.RegistrationService;
import com.company.demo.view.login.LoginView;
import com.vaadin.flow.component.ClickEvent;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.router.Route;
import com.vaadin.flow.server.auth.AnonymousAllowed;
import io.jmix.flowui.ViewNavigators;
import io.jmix.flowui.component.textfield.JmixPasswordField;
import io.jmix.flowui.component.textfield.TypedTextField;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

@AnonymousAllowed
@Route(value = "registration")
@ViewController("RegistrationView")
@ViewDescriptor("registration-view.xml")
public class RegistrationView extends StandardView {

    @ViewComponent
    private TypedTextField<String> firstNameField;
    @ViewComponent
    private TypedTextField<String> lastNameField;
    @ViewComponent
    private TypedTextField<String> usernameField;
    @ViewComponent
    private TypedTextField<String> emailField;
    @ViewComponent
    private JmixPasswordField passwordField;

    @Autowired
    private ViewNavigators viewNavigators;
    @Autowired
    private RegistrationService registrationService;

    @Subscribe("registerBtn")
    public void onRegisterBtnClick(final ClickEvent<Button> event) {
        // some exception handling is needed in case username
        // or email are already taken or password too weak
        registrationService.register(
                firstNameField.getValue(),
                lastNameField.getValue(),
                usernameField.getValue(),
                emailField.getValue(),
                passwordField.getValue()
        );

        navigateToLoginView();

    }

    @Subscribe("alreadyRegisteredBtn")
    public void onAlreadyRegisteredBtnClick(final ClickEvent<Button> event) {
        navigateToLoginView();
    }

    private void navigateToLoginView() {
        viewNavigators.view(LoginView.class)
                .navigate();
    }
}